#pragma once

#define ADMXRC3_EXPORT
#define ADMXRC3_CALLING_CONVENTION

#include <admxrc3/platform.h>
#include <admxrc3/status.h>
#include <admxrc3/types.h>
#include <admxrc3/structs.h>
#include <admxrc3/ticket.h>

/*
** Function prototypes for ADMXRC3
*/
#ifdef __cplusplus
extern "C" {
#endif

ADMXRC3_EXPORT ADMXRC3_STATUS
ADMXRC3_CALLING_CONVENTION
ADMXRC3_Close(
  ADMXRC3_HANDLE             hCard);

ADMXRC3_EXPORT ADMXRC3_STATUS
ADMXRC3_CALLING_CONVENTION
ADMXRC3_GetCardInfoEx(
  ADMXRC3_HANDLE             hCard,
  ADMXRC3_CARD_INFOEX*       pCardInfoEx);

#if defined(_UNICODE)
# define ADMXRC3_GetFpgaInfo ADMXRC3_GetFpgaInfoW
#else
# define ADMXRC3_GetFpgaInfo ADMXRC3_GetFpgaInfoA
#endif

ADMXRC3_EXPORT ADMXRC3_STATUS
ADMXRC3_CALLING_CONVENTION
ADMXRC3_GetFpgaInfoA(
    ADMXRC3_HANDLE hCard,
    unsigned int targetIndex,
    ADMXRC3_FPGA_INFOA* pFpgaInfo);

ADMXRC3_EXPORT ADMXRC3_STATUS
ADMXRC3_CALLING_CONVENTION
ADMXRC3_GetFpgaInfoW(
    ADMXRC3_HANDLE hCard,
    unsigned int targetIndex,
    ADMXRC3_FPGA_INFOW* pFpgaInfo);

#if defined(_UNICODE)
# define ADMXRC3_GetStatusString ADMXRC3_GetStatusStringW
#else
# define ADMXRC3_GetStatusString ADMXRC3_GetStatusStringA
#endif

ADMXRC3_EXPORT const char*
ADMXRC3_CALLING_CONVENTION
ADMXRC3_GetStatusStringA(
  ADMXRC3_STATUS             code,
  _ADMXRC3_BOOL              bShort);

ADMXRC3_EXPORT const wchar_t*
ADMXRC3_CALLING_CONVENTION
ADMXRC3_GetStatusStringW(
  ADMXRC3_STATUS             code,
  _ADMXRC3_BOOL              bShort);

ADMXRC3_EXPORT ADMXRC3_STATUS
ADMXRC3_CALLING_CONVENTION
ADMXRC3_GetVersionInfo(
  ADMXRC3_HANDLE             hCard,
  ADMXRC3_VERSION_INFO*      pVersionInfo);

ADMXRC3_EXPORT ADMXRC3_STATUS
ADMXRC3_CALLING_CONVENTION
ADMXRC3_GetWindowInfo(
  ADMXRC3_HANDLE             hCard,
  unsigned int               windowIndex,
  ADMXRC3_WINDOW_INFO*       pWindowInfo);

ADMXRC3_EXPORT ADMXRC3_STATUS
ADMXRC3_CALLING_CONVENTION
ADMXRC3_Open(
  unsigned int               index,
  ADMXRC3_HANDLE*            phCard);

ADMXRC3_EXPORT ADMXRC3_STATUS
ADMXRC3_CALLING_CONVENTION
ADMXRC3_OpenEx(
  unsigned int               index,
  _ADMXRC3_BOOL              bReadOnly,
  _ADMXRC3_UINT32            cooperativeLevel,
  ADMXRC3_HANDLE*            phCard);

#ifdef __cplusplus
}
#endif

/*
** Function prototypes for ADMXRC3D
*/

#ifdef __cplusplus
extern "C" {
#endif

ADMXRC3_EXPORT ADMXRC3_STATUS
ADMXRC3_CALLING_CONVENTION
ADMXRC3_GetSensorInfoA(
  ADMXRC3_HANDLE             hCard,
  unsigned int               sensorIndex,
  ADMXRC3_SENSOR_INFOA*     pSensorInfo);

ADMXRC3_EXPORT ADMXRC3_STATUS
ADMXRC3_CALLING_CONVENTION
ADMXRC3_GetSensorInfoW(
  ADMXRC3_HANDLE             hCard,
  unsigned int               sensorIndex,
  ADMXRC3_SENSOR_INFOW*     pSensorInfo);

#if defined(_UNICODE)
# define ADMXRC3_GetSensorInfo ADMXRC3_GetSensorInfoW
#else
# define ADMXRC3_GetSensorInfo ADMXRC3_GetSensorInfoA
#endif

ADMXRC3_EXPORT ADMXRC3_STATUS
ADMXRC3_CALLING_CONVENTION
ADMXRC3_ReadSensor(
  ADMXRC3_HANDLE             hCard,
  unsigned int               sensorIndex,
  ADMXRC3_SENSOR_VALUE*     pValue);

#ifdef __cplusplus
}
#endif
