#pragma once

#define ARRAY_LENGTH(x) (sizeof(x) / sizeof((x)[0]))

typedef BOOL bool_t;

typedef COLORREF color_t;

typedef CWnd& control_handle_t;

typedef CWnd& window_handle_t;

typedef INT64 timestamp_t;
#define TIMESTAMP_INVALID ((timestamp_t)-1)

__inline static timestamp_t
getTimeNow(void) {
  LARGE_INTEGER count, frequency;
  BOOL bSuccess;

  QueryPerformanceCounter(&count);
  bSuccess = QueryPerformanceFrequency(&frequency);
  ASSERT(bSuccess);
  if (bSuccess) {
    return (timestamp_t)((double)count.QuadPart * 1000.0 / (double)frequency.QuadPart);
  } else {
    return 0;
  }
}

__inline static void
debugPrint(TCHAR* fmt, ...) {
  va_list ap;
  TCHAR buf[256];

  va_start(ap, fmt);
  _vstprintf_s(buf, ARRAY_LENGTH(buf), fmt, ap);
  va_end(ap);

  OutputDebugString(buf);
}
