--==============================================================================
--
--     File Name: adb3_target_pkg_pcie.vhd
--       Version: 0.1
--          Date: 26 Aug 2011
--         Model: Synthesisable
--
--  Dependencies: Set simulator resolution to ps for accurate simulation
--
--       Company: Alpha Data
--        Design: Package adb3_target_pkg
--
--   Description: Package of components used in target FPGAs using ADB3 PCIe.
--
--   Limitations:
--
--         Notes:
--
--    Disclaimer: THESE DESIGNS ARE PROVIDED "AS IS" WITH NO WARRANTY
--                WHATSOEVER AND ALPHA DATA SPECIFICALLY DISCLAIMS ANY
--                IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR
--                A PARTICULAR PURPOSE, OR AGAINST INFRINGEMENT.
--
--                Copyright (C) 2011 Alpha Data, All rights reserved
--
--     Revisions: 0.1, KDC, 26 Aug 2011: Initial design
--
--==============================================================================

--
-- Exported components:
--
--   pcie_if_target_wrap
--

library ieee;
use ieee.std_logic_1164.all;

library work;
use work.adb3_ocp.all;
use work.adb3_target_inc_pkg.all;

package adb3_target_pkg is

  -----------------------------------
  -- Target component declarations --
  -----------------------------------

  component pcie_if_target_wrap
  port(
    ref_clk          : in    std_logic;
    -- OCP Interface
    ocp_clk          : in    std_logic;
    direct_slave_m2s : out   adb3_ocp_m2sT;
    direct_slave_s2m : in    adb3_ocp_s2mT;
    dma_channels_m2s : out   adb3_ocp_m2sT_array(0 to DMA_CHANNELS-1);
    dma_channels_s2m : in    adb3_ocp_s2mT_array(0 to DMA_CHANNELS-1);
    dma_abort        : in    std_logic_vector(DMA_CHANNELS-1 downto 0);
    interrupt        : in    std_logic;
    -- PCIe Interface
    pcie_rst_l       : in    std_logic;
    pcie_clk         : in    std_logic_dbl_t;
    pcie_h2t         : in    pcie_h2t_t;
    pcie_t2h         : out   pcie_t2h_t;
    -- Board IO
    model_in         : in    adb3_model_in_t;
    model_out        : out   adb3_model_out_t;
    model_inout      : inout adb3_model_inout_t);
  end component;

end;


package body adb3_target_pkg is

end;
