quit -sim

# Delete existing libraries
file delete -force -- work
vlib work

# Compile source code
# ADB3 OCP library
vcom -93 "../../../common/adb3_ocp/adb3_ocp_pkg.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_comp_pkg.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_simple_bus_if.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_tb_pkg.vhd"

# ADB3 Target
vcom -93 "../../../common/adb3_target/adb3_target_types_pkg.vhd"
vcom -93 "../../../common/adb3_target/admxrc6tadv8/adb3_target_inc_pkg_sim_ocp_6tadv8_pcie.vhd"
vcom -93 "../../../common/adb3_target/adb3_target_pkg_pcie.vhd"
vcom -93 "../../../common/adb3_target/admxrc6tadv8/pcie_target/pcie_if_target_wrap_sim_6tadv8.vhd"

# Simple design
vcom -93 "../common/simple_l_pcie.vhd"

# Compile testbench source code
# AD DDR3 Memory Model
vcom -93 "../../../common/mem_tb/ddr3_sdram/ddr3_sdram_pkg.vhd"

# ADB3 OCP probe
vcom -93 "../../../common/adb3_probe/adb3_probe_pkg.vhd"
vcom -93 "../../../common/adb3_probe/adb3_ocp_transaction_probe_sim.vhd"

# ADB3 Target
vcom -93 "../../../common/adb3_target/admxrc6tadv8/adb3_target_tb_inc_pkg_6tadv8.vhd"
vcom -93 "../../../common/adb3_target/adb3_target_tb_pkg_pcie.vhd"
vcom -93 "../../../common/adb3_target/admxrc6tadv8/pcie_host/pcie_if_host_wrap_sim_6tadv8.vhd"
vcom -93 "../../../common/adb3_target/admxrc6tadv8/test_board_clks_6tadv8.vhd"

# Simple Testbench
vcom -93 "../common/test_simple_pcie.vhd"

vsim -t ps test_simple

set VAR_BOARD      [examine /adb3_target_tb_inc_pkg/BOARD_TYPE]
set VAR_USE        [examine /adb3_target_inc_pkg/TARGET_USE]
set VAR_WRAP  PCIex[examine /adb3_target_inc_pkg/PCIE_SER_WIDTH]

set wave_pat {
/test_simple/*
/test_simple/uut/*
}

set wave_rad {
hexadecimal {data q}
}

view signals
view structure
view wave -title "simple (${VAR_BOARD}, ${VAR_WRAP}, ${VAR_USE})"

foreach pattern $wave_pat {
add wave -group $pattern $pattern
}
configure wave -signalnamewidth 1

foreach {radix signals} $wave_rad {
foreach signal $signals {
catch {property wave -radix $radix $signal}
}
}

radix hex

run 1 ms
