quit -sim
set VAR_DIR admxrc6tl
set VAR_MIG v3_6

# Execute script to generate 'today package'
exec xtclsh ../gen_today_pkg.tcl today_pkg_${VAR_DIR}_sim.vhd >today_pkg_${VAR_DIR}_sim.vhd

# Delete existing libraries
file delete -force -- work
vlib work

# Compile source code
# Compile source code
# DDR3 MIG Core
if { [catch {
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ui/ui_cmd.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ui/ui_rd_data.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ui/ui_wr_data.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ui/ui_top.vhd"

  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ecc/ecc_merge_enc.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ecc/ecc_dec_fix.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ecc/ecc_buf.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ecc/ecc_gen.vhd"

  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/circ_buffer.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_ck_iob.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_clock_io.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_control_io.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_data_io.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_dly_ctrl.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_dm_iob.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_dq_iob.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_dqs_iob.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_init.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_pd.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_pd_top.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_rdclk_gen.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_rdctrl_sync.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_rddata_sync.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_rdlvl.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_read.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_write.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_wrlvl.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/rd_bitslip.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/phy/phy_top.vhd"

  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/arb_mux.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/arb_row_col.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/arb_select.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/bank_cntrl.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/bank_common.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/bank_compare.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/bank_mach.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/bank_queue.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/bank_state.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/col_mach.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/rank_cntrl.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/rank_common.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/rank_mach.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/round_robin_arb.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/controller/mc.vhd"

  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ip_top/mem_intfc.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ip_top/infrastructure.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ip_top/c0_memc_ui_top.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ip_top/c1_memc_ui_top.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ip_top/c2_memc_ui_top.vhd"
  vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/rtl/mig_${VAR_MIG}/ip_top/c3_memc_ui_top.vhd"
} msg] } then {
  echo
  echo All DDR3 MIG ${VAR_MIG} files for ${VAR_DIR} are not found.
  echo
  echo Please re-run this macro file after generating the
  echo DDR3 MIG ${VAR_MIG} files by running
  echo
  echo   xtclsh gen_mem_if.tcl ${VAR_DIR}
  echo
  echo in a command console in directory:
  echo
  echo   hdl/vhdl/common/mem_if/ddr3_sdram
  echo
  return -1
} else {
  echo
  echo All DDR3 MIG ${VAR_MIG} files for ${VAR_DIR} are found.
  echo }

# FIFO library
vcom -93 "../../../common/dpmem/dpmem_pkg.vhd"
vcom -93 "../../../common/dpmem/distmem0.vhd"
vcom -93 "../../../common/dpmem/distmem.vhd"
vcom -93 "../../../common/dpmem/dpbram0.vhd"
vcom -93 "../../../common/dpmem/dpbram.vhd"
vcom -93 "../../../common/fifo/fifo_pkg.vhd"
vcom -93 "../../../common/fifo/afifo.vhd"

# ADB3 OCP library
vcom -93 "../../../common/adb3_ocp/adb3_ocp_pkg.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_comp_pkg.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_cross_clk_dom.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_retime_nb.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_simple_bus_if.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_simple_bus_if_nb.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_split_b.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_split_nb.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_mux_nb.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_ocp2ddr3_nb.vhd"

# ADB3 Target
vcom -93 "../../../common/adb3_target/adb3_target_types_pkg.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/adb3_target_inc_pkg_sim_ocp_6tl.vhd"
vcom -93 "../../../common/adb3_target/adb3_target_pkg.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_target/mptl_if_target_wrap_sim_6tl.vhd"

# Memory Interface
vcom -93 "../../../common/mem_if/mem_if_pkg.vhd"
vcom -93 "../../../common/mem_if/ddr3_sdram/${VAR_DIR}/ddr3_if_bank_6tl.vhd"

# Memory Applications
vcom -93 "../../../common/mem_apps/blk_mem_test.vhd"

# Chipscope simulation block (optional)
vcom -93 "../../../common/chipscope/blk_chipscope_sim.vhd"

# Uber design
vcom -93 "../${VAR_DIR}/today_pkg_${VAR_DIR}_sim.vhd"
vcom -93 "../common/uber_pkg.vhd"
vcom -93 "../${VAR_DIR}/blk_clocks_6tl.vhd"
vcom -93 "../common/blk_ds_simple_test.vhd"
vcom -93 "../common/blk_clock_freq.vhd"
vcom -93 "../${VAR_DIR}/blk_ds_clk_read_6tl.vhd"
vcom -93 "../${VAR_DIR}/blk_ds_io_test_6tl.vhd"
vcom -93 "../common/blk_ds_int_test.vhd"
vcom -93 "../common/blk_ds_mem_reg.vhd"
vcom -93 "../common/blk_ds_info.vhd"
vcom -93 "../common/blk_direct_slave.vhd"
vcom -93 "../common/bram_single_wrap.vhd"
vcom -93 "../common/blk_bram.vhd"
vcom -93 "../common/blk_dma_switch.vhd"
vcom -93 "../common/blk_mem_app.vhd"
vcom -93 "../${VAR_DIR}/blk_mem_if_6tl.vhd"
vcom -93 "../common/uber.vhd"

# Compile testbench source code
# AD DDR3 Memory Model
vcom -93 "../../../common/mem_tb/ddr3_sdram/ddr3_sdram_pkg.vhd"
vcom -93 "../../../common/mem_tb/ddr3_sdram/ddr3_sdram_int_pkg.vhd"
vcom -93 "../../../common/mem_tb/ddr3_sdram/ddr3_sdram_dly_cnt.vhd"
vcom -93 "../../../common/mem_tb/ddr3_sdram/ddr3_sdram_timing_chk.vhd"
vcom -93 "../../../common/mem_tb/ddr3_sdram/ddr3_sdram_main_fsm.vhd"
vcom -93 "../../../common/mem_tb/ddr3_sdram/ddr3_sdram_init_fsm.vhd"
vcom -93 "../../../common/mem_tb/ddr3_sdram/ddr3_sdram.vhd"

# ADB3 OCP testbench
vcom -93 "../../../common/adb3_ocp/adb3_ocp_tb_pkg.vhd"

# ADB3 OCP probe
vcom -93 "../../../common/adb3_probe/adb3_probe_pkg.vhd"
vcom -93 "../../../common/adb3_probe/adb3_ocp_transaction_probe_sim.vhd"

# ADB3 Target
vcom -93 "../../../common/adb3_target/${VAR_DIR}/adb3_target_tb_inc_pkg_6tl.vhd"
vcom -93 "../../../common/adb3_target/adb3_target_tb_pkg.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_bridge/mptl_if_bridge_wrap_sim_6tl.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/test_board_clks_6tl.vhd"

# Uber Testbench
vcom -93 "../${VAR_DIR}/uber_tb_pkg_6tl.vhd"
vcom -93 "../common/test_uber_ds.vhd"
vcom -93 "../common/test_uber_dm.vhd"
vcom -93 "../common/test_uber_dma_1ch_nb.vhd"
vcom -93 "../common/test_uber_probes.vhd"
vcom -93 "../${VAR_DIR}/test_uber_mem_6tl.vhd"
vcom -93 "../common/test_uber.vhd"

# Define level of on-board RAM model message reporting
set var_message_level 0

vsim -t ps -L unisim -Gmessage_level=${var_message_level} test_uber

set VAR_BOARD      [examine /adb3_target_tb_inc_pkg/BOARD_TYPE]
set VAR_USE        [examine /adb3_target_inc_pkg/TARGET_USE]
set VAR_WRAP       MPTL

set VAR_DDR3_BANKS [examine -radix decimal /adb3_target_inc_pkg/DDR3_BANKS]
set VAR_DDR3_ROW   [examine -radix decimal /adb3_target_tb_inc_pkg/BOARD_DDR3_BANK_ROW_WIDTH]
set VAR_DDR3_PART  [expr int(pow(2,${VAR_DDR3_ROW}-13))]

set wave_pat {
/test_uber/*
/test_uber/uut/*

/test_uber/uut/blk_direct_slave_i/*
/test_uber/uut/blk_direct_slave_i/blk_ds_clk_read_i/*

/test_uber/uut/blk_dma_switch_i/*
/test_uber/uut/blk_dma_switch_i/dma_split_g__0/adb3_ocp_split_nb_dma_i/*
/test_uber/uut/blk_dma_switch_i/mux_ram_g__1/adb3_ocp_mux_nb_ram_i/*

/test_uber/uut/blk_mem_if_i/*
/test_uber/uut/blk_mem_if_i/ddr3_if_g__1/ddr3_if_bank_i/*
/test_uber/uut/blk_mem_if_i/ddr3_if_g__1/ddr3_if_bank_i/bank1_g/adb3_ocp_ocp2ddr3_nb_i/*

/test_uber/test_uber_mem_i/ddr3_model_g__1/ddr3_sdram_bank_ls_i/*
/test_uber/test_uber_mem_i/ddr3_model_g__1/ddr3_sdram_bank_ls_i/ddr3_sdram_main_fsm_i/*
}

set wave_rad {
hexadecimal {data q}
}

view signals
view structure
view wave -title "uber (${VAR_BOARD}, ${VAR_WRAP}, ${VAR_DDR3_BANKS}x2x${VAR_DDR3_PART}Gib DDR3 MIG ${VAR_MIG}, ${VAR_USE})"
foreach pattern $wave_pat {
add wave -group $pattern $pattern
}
configure wave -signalnamewidth 1

foreach {radix signals} $wave_rad {
foreach signal $signals {
catch {property wave -radix $radix $signal}
}
}

radix hex

# Disabled for Coregen MIG DDR3 SDRAM interface
set NumericStdNoWarnings 1
set StdArithNoWarnings 1

run 1 ms
